﻿using System;
using Telerik.Windows.Documents.Model;
using System.Windows.Controls;
using Telerik.Windows.Documents.FormatProviders.Html;
using System.Windows;
using System.Reflection;
using System.IO;
using Telerik.Windows.Documents.Layout;
using Telerik.Windows.Documents;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        private RadDocumentBindingSource bindingSource = new RadDocumentBindingSource();
        public MainPage()
        {
            InitializeComponent();
        }

        private Uri GetResourceUri(string resource)
        {
            AssemblyName assemblyName = new AssemblyName(this.GetType().Assembly.FullName);
            string resourcePath = "/" + assemblyName.Name + ";component/" + resource;
            Uri resourceUri = new Uri(resourcePath, UriKind.Relative);

            return resourceUri;
        }

        private void MeasureAndArrangeInDefaultSize(RadDocument document)
        {
            document.Measure(RadDocument.MAX_DOCUMENT_SIZE);
            document.Arrange(new RectangleF(PointF.Empty, document.DesiredSize));
        }

        private void MergeDocuments()
        {
            SaveFileDialog sfd = new SaveFileDialog();

            if (sfd.ShowDialog() == true)
            {
                RadDocument htmlDoc1, htmlDoc2;

                HtmlFormatProvider provider = new HtmlFormatProvider();

                using (Stream stream = Application.GetResourceStream(
                    this.GetResourceUri("Documents\\HtmlDoc1.html")).Stream)
                {
                    htmlDoc1 = provider.Import(stream);
                }

                this.MeasureAndArrangeInDefaultSize(htmlDoc1);

                using (Stream stream = Application.GetResourceStream(
                    this.GetResourceUri("Documents\\HtmlDoc2.html")).Stream)
                {
                    htmlDoc2 = provider.Import(stream);
                }

                this.MeasureAndArrangeInDefaultSize(htmlDoc2);

                htmlDoc2.Selection.SelectAll();

                DocumentFragment fragment = htmlDoc2.Selection.CopySelectedDocumentElements();

                htmlDoc1.CaretPosition.MoveToLastPositionInDocument();
                htmlDoc1.InsertInline(new Span(Environment.NewLine));
                htmlDoc1.InsertFragment(fragment);

                this.MeasureAndArrangeInDefaultSize(htmlDoc2);

                using (var outStream = sfd.OpenFile())
                {
                    provider.Export(htmlDoc1, outStream);
                }
                htmlDoc1.Measure(RadDocument.MAX_DOCUMENT_SIZE);
                htmlDoc1.Arrange(new RectangleF(PointF.Empty, htmlDoc1.DesiredSize));

                htmlDoc1.LayoutMode = DocumentLayoutMode.Paged;

                htmlDoc1.DefaultPageLayoutSettings.Width = 700;
                htmlDoc1.DefaultPageLayoutSettings.Height = 700;
                htmlDoc1.SectionDefaultPageMargin = new Padding(55);
                htmlDoc1.Sections.First.PageMargin = new Padding(55);

                htmlDoc1.UpdateLayout();

                this.book.RightPageIndex = 0; 

                this.viewManager.Document = htmlDoc1;
                bindingSource.Document = htmlDoc1;
                    
              //  this.radRichTextBox1.Document = htmlDoc1;

                this.book.ItemsSource = bindingSource;
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            this.MergeDocuments();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
           
        }
    }
}
